



////////////////////////////////////////////////////////////////////////
//
// this class represents the framerate display
//
// note: this is a static class
//
////////////////////////////////////////////////////////////////////////



package si.debug
{

	include "../siImportFile.as"

	

	//////////////////////////////////////////////////////////////////////////////////
	//
	//
	//////////////////////////////////////////////////////////////////////////////////
    	public class FrameRate
    	{

    		private static var text:TextField;

    		private static var is_active:Boolean;

		private static var top_ever:Number;
		private static var bottom_ever:Number;

		private static var rate_avg:Number = 0;
		
		private static var pobj:DisplayObjectContainer;
		
    		private static var times_to_sample:int = 60;
		private static var sample_count:Number = 0;



		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public static function start(disp_obj_cont:DisplayObjectContainer):void
		{
			if (is_active == true)
				return;

			pobj = disp_obj_cont;

			is_active = true;
			top_ever = 0.0;
			bottom_ever = 9999.0;
		
			text = new TextField();
			text.autoSize = TextFieldAutoSize.LEFT;
			text.text = "";	
			text.textColor = 0xff000000;
			text.x = 430;
			text.y = 35;
			disp_obj_cont.addChild(text);



		}

		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public static function update(time_diff:int):void
		{

			if (is_active)
			{
				if (sample_count < times_to_sample) 
					sample_count++;
			
				//to get on top of everything else
				pobj.removeChild(text);
				pobj.addChild(text);
				
				//create space to add in latest rate number
				rate_avg -= (rate_avg/times_to_sample);

				//add in new diff
				rate_avg += 1000/time_diff;

				var num:Number = rate_avg/times_to_sample;

				if (sample_count >= times_to_sample)
				{				
					if (num < bottom_ever)
						bottom_ever = num;
					if (num > top_ever)
						top_ever = num;
				}
				
				//show values
				text.text =  top_ever.toFixed(0) + "/" + bottom_ever.toFixed(0) + "/" + num.toFixed(0);

			}
		}

	}
}