


////////////////////////////////////////////////////////////////////////
//
// this class represents vector math
//
// note: this is a static class
//
////////////////////////////////////////////////////////////////////////



package si.math
{

	include "../siImportFile.as"


	//////////////////////////////////////////////////////////////////////////////////
	//
	//
	//////////////////////////////////////////////////////////////////////////////////
    	public class Vector
    	{

		////////////////////////////////////////////////////////////////////////////////////
		//
		//
		////////////////////////////////////////////////////////////////////////////////////
		public static function getMagnitude(vec:Point):int
		{
			return Math.sqrt(vec.x * vec.x + vec.y * vec.y);
	        }
	        
	        

		////////////////////////////////////////////////////////////////////////////////////
		//
		//
		////////////////////////////////////////////////////////////////////////////////////
		public static function normalize(vec:Point):Point
		{
			var len:Number = (vec.x * vec.x) +
					  (vec.y * vec.y);
		
			if(len > 0.0)
			{
				len = (1/Math.sqrt(len));
		
				vec.x *= len;
				vec.y *= len;
			}
			
			return vec;
		}

	
		////////////////////////////////////////////////////////////////////////////////////
		//
		//
		////////////////////////////////////////////////////////////////////////////////////
		public static function scale(vec:Point, scale:int):Point
		{
			vec.x *= scale;
			vec.y *= scale;
			
			return vec;
		}
	

	}
	
}