

////////////////////////////////////////////////////////////////////////
//
// dsd hey brother tori - will miss you dearly.
// dsd deepak
// dsd 3/8/2008
//
////////////////////////////////////////////////////////////////////////


package
{

	include "ImportFile.as"


	public class Bar extends GameObj
	{

		private var do_action:Boolean = false;

		private var game_state:GameStatePlay;
		
		private var rot_amt:Number =  0.1884;

		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public function Bar(game:Game, pobj:Sprite, x:int, y:int, in_game_state:GameStatePlay, rot:Number)
		{

			rot_amt = ((Cabol)(game)).bar_rot_amt;


			//store game state
			game_state = in_game_state;

			//set collision info
			var coll_cat:uint = CollInfo.COLL_CATEGORY_BAR;
			var coll_mask:uint = CollInfo.COLL_CATEGORY_BALL|CollInfo.COLL_CATEGORY_BARRIER|CollInfo.COLL_CATEGORY_FLOWER|CollInfo.COLL_CATEGORY_EGG|CollInfo.COLL_CATEGORY_MECHANIX|CollInfo.COLL_CATEGORY_BARRIER_OUTER;

			//call super constructor
			super(game, pobj, new Point(x, y), new Point(70,10),GameObj.FLAG_DISPLAYABLE | GameObj.FLAG_COLLIDABLE,coll_cat, coll_mask);	


			//set angular damping tight so that bar doesn't just spin around
			//too much when it gets hit
			setAngularDamping(0.0);

			//create mouse joint for this bar
			//the mouse joint is a coll system object that follows the mouse around
			//the bar then follows the mousejoint around
			//it's better than following the mouse direcly, because the mouse
			//joint has some built-in/adjustable lag
			//there were some other nasty issues of just following the as3 mouse
			//	info, i just can't remember what they were
			createMouseJoint();			

			//init event listeners for mouse			
			game.getStage().addEventListener(MouseEvent.MOUSE_DOWN, setAction);
			game.getStage().addEventListener(MouseEvent.MOUSE_UP, clearAction);
						
						
		}


		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public override function shutdown():void
		{
			game.getStage().removeEventListener(MouseEvent.MOUSE_DOWN, setAction);
			game.getStage().removeEventListener(MouseEvent.MOUSE_UP, clearAction	);

			destroyMouseJoint();

			super.shutdown();
		}
		
		

		////////////////////////////////////////////////////////////////////////
		//
		// 
		//
		////////////////////////////////////////////////////////////////////////
		public override function update(time_diff:int):void
		{	
			
			if (do_action)
				coll_body.m_rotation += rot_amt;
		}
		

		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public override function draw():void
		{
			graphics.clear();

			if (rot_amt > 0.0)
			{
				graphics.lineStyle(2, 0xe00000, 1.0, false);
				graphics.beginFill(0xff0000);
			}
			else 
			{
				graphics.lineStyle(2, 0x0000e0, 1.0, false);
				graphics.beginFill(0x0000ff);
			}
			graphics.drawEllipse((-size.x/2) * 1.0,(-size.y/2) * 2.0,size.x * 1.0,size.y * 2.0);
			graphics.endFill();			

			if (rot_amt > 0.0)
			{
				graphics.beginFill(0xff8000);
			}
			else
			{
				graphics.beginFill(0x0080ff);
			}
			
			graphics.drawEllipse(-size.x/2,0-size.y/2,size.x * 0.75,size.y * 1.25);
			graphics.endFill();			

		}
		
		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function setAction(event:Event):void { do_action = true; }
		public function clearAction(event:Event):void { do_action = false; }


		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function changeDirection():void
		{
			rot_amt *= -1; 
			((Cabol)(game)).bar_rot_amt = rot_amt;

			draw();
		}


		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function getRotAmt():Number { return rot_amt; }

	}
} 