

////////////////////////////////////////////////////////////////////////
//
// bin is actually a super object that represents the bin's
// subparts
//
////////////////////////////////////////////////////////////////////////


package
{

	include "ImportFile.as"


	public class Bin extends GameObj
	{
		private var collector:Collector;
		private var collector_glow:CollectorGlow;
		private var barrier_left:Barrier;
		private var barrier_right:Barrier;


		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public function Bin(game:Game, pobj:Sprite, pos:Point, in_size:Point, flags:uint)
		{

			//call super contructor
			super(game, pobj, pos, in_size, flags,0,0);

			//setup flags for walls
			var temp_flags:uint = GameObj.FLAG_COLLIDABLE_SOLID;

			//setup wall size
			var size_wall:Point = new Point(10,in_size.y);

			//make collidable side walls of bins			
			barrier_left = new Barrier(game,this,new Point(-this.size.x/2 + size_wall.x/2, 0), size_wall, temp_flags,false,Barrier.TYPE_REG);
			barrier_right = new Barrier(game,this,new Point(this.size.x/2 - size_wall.x/2, 0), size_wall, temp_flags,false,Barrier.TYPE_REG);


			//setup collector
			var size_collector:Point = new Point(this.size.x - (size_wall.x * 2),size_wall.y - 20);
			collector = new Collector(game,this,new Point(0,20), size_collector);


			//setup collector glow
			var size_inner:Point = new Point(this.size.x * 0.65, this.size.y * 0.65);
			var red_glow:Boolean = false;
			if (size.x == 70)
				red_glow = true;
			collector_glow = new CollectorGlow(game,this,new Point(0,0), size_inner,red_glow);

		}



		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public override function shutdown():void
		{
			collector_glow.shutdown();

			collector.shutdown();
			barrier_right.shutdown();
			barrier_left.shutdown();
	
			super.shutdown();

		}
	

	
		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public override function draw():void
		{

			graphics.clear();




			var c:Array = new Array();
			var a:Array = new Array();
			var r:Array = new Array();

			c = [0x008000,0x055000];
			a = [1,1];
			r = [0,255];

			graphics.lineStyle(2, 0x008000, 1.0, false);



			var mat:Matrix = new Matrix();
			mat.createGradientBox(size.x/2,size.y/2,1.57,0,0);	

			graphics.beginGradientFill(GradientType.LINEAR,
				       c,
				       a,
				       r,
				       mat,
				       SpreadMethod.PAD,
				       InterpolationMethod.RGB,
				       0.0);

			graphics.drawRoundRect(-size.x/2,-size.y/2 - 5,size.x/8,size.y*0.1,10,10);
			graphics.drawRoundRect( size.x/2 - ((size.x/8) * 1.0),-size.y/2 - 5,size.x/8,size.y*0.1,10,10);

			graphics.drawRoundRect(-size.x/2,-size.y/2,size.x,size.y,10,10);

			graphics.endFill();

			c = [0x108000,0x208000];
			graphics.beginGradientFill(GradientType.LINEAR,
				       c,
				       a,
				       r,
				       mat,
				       SpreadMethod.PAD,
				       InterpolationMethod.RGB,
				       0.0);

			graphics.drawRoundRect(-size.x/2*0.8,-size.y/2*0.8,size.x*0.8,size.y*0.8,50,50);
			graphics.endFill();		


			c = [0x00ff00,0x004000];
			mat.createGradientBox(size.x,size.y,0.0,0,0);	
			graphics.beginGradientFill(GradientType.LINEAR,
				       c,
				       a,
				       r,
				       mat,
				       SpreadMethod.REFLECT,
				       InterpolationMethod.RGB,
				       0.0);

			graphics.drawRoundRect(-size.x/2,-size.y/2,size.x,size.y*0.05,10,10);
			graphics.endFill();		

		}

	
	}
}