

///////////////////////////////////////////////////////////////////////
//
// and bud is a pre-egg - shot from the flower
//
////////////////////////////////////////////////////////////////////////


package 
{
	include "ImportFile.as"


	public class Bud extends GameObj
	{
	
		private var game_state:GameState;
		
	
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function Bud(game:Game, pobj:Sprite, pos:Point, in_game_state:GameState)
		{
			//store game state
			game_state = in_game_state;
		
			//set coll info
			var coll_cat:uint = CollInfo.COLL_CATEGORY_BUD;
			var coll_mask:uint = CollInfo.COLL_CATEGORY_NONE;
			
			//call super constructor
			super(game, pobj, pos, new Point(10, 10),GameObj.FLAG_DISPLAYABLE | GameObj.FLAG_COLLIDABLE,coll_cat, coll_mask);
			
			//give it a random kick start vel
			var thevel:Point = new Point();
			thevel.x = (Random.getInt(300) - 150);
			thevel.y = -(Random.getInt(75) + 450);
			setVelAdj(thevel);
		
		
		}
		


		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public override function shutdown():void
		{
			super.shutdown();
		}
		
	
		////////////////////////////////////////////////////////////////////////
		//
		// 
		//
		////////////////////////////////////////////////////////////////////////
		public override function update(time_diff:int):void
		{
	
			//call update of parent
			super.update(time_diff);


			//get vel of bud
			var v:b2Vec2 = coll_body.GetLinearVelocity();
			var vel:Point = new Point(v.x,v.y);


			//determine if bud should become an egg
			if (vel.y >= 0)
			{
				//create an egg and add it to game obj list
				var egg:Egg;
				egg = new Egg(game, game, this.x,this.y);
				((GameStatePlay)(game_state)).gameObjListAdd(egg);

				//have bud set itself for deletion
				delete_me = true;
			}

			//draw each frame because its animating
			draw();			

		}



		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public override function draw():void
		{
			graphics.clear();

			graphics.lineStyle(5, Random.getInt(16777215), 1.0, false);
			graphics.beginFill(Random.getInt(16777215));
			graphics.drawCircle(0,0,size.x);
			graphics.endFill();			
		}
	}
}