

 
////////////////////////////////////////////////////////////////////////
//
//
//
////////////////////////////////////////////////////////////////////////



package
{

	include "ImportFile.as"


	public class Cabol extends Game
	{
	
		//game states
		public static const GAME_STATE_INTRO:int    	= 0;	
		public static const GAME_STATE_PLAY:int      	= 1;		
		public static const GAME_STATE_FINAL:int        = 2;		
							
		private var game_level:int = 0;		
		
		public var array_flower_info:Array;

		public var apiConnection:*;

		public var bar_rot_amt:Number =  0.1884;


		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function Cabol(in_stage:Stage,in_screen_size:Point):void
		{
			//call super constructor
			super(in_stage,in_screen_size,GAME_STATE_INTRO,false);

			resetGame();

			//one time init of all sounds for game
			GameSounds.init();

		
		}


	
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public override function shutdown():void
		{
	
			GameSounds.shutdown();		
	
			super.shutdown();
		}





		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		protected override function update(event:Event):void
		{

			//call parents update func
			super.update(event);
		

			//init game state obj if null
			if (game_state_obj == null)
			{
				if (game_state == GAME_STATE_INTRO)
					game_state_obj = new GameStateIntro(this);
				else if (game_state == GAME_STATE_PLAY)
					game_state_obj = new GameStatePlay(this);
				else //if (game_state == GAME_STATE_FINAL)
					game_state_obj = new GameStateFinal(this);
			}
	
			//execute current game state
			game_state_obj.go();


		}

		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function resetGame():void
		{
			game_level = 0; 

			//re-init flower array
			//the flower array holds flowers that the player has saved
			//	over the life of one game
			array_flower_info = new Array();

		}		
		

		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function getGameLevel():int { return game_level; }
		public function incGameLevel():void  { game_level++; }		



		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function drawLoadingBackground():void
		{
			graphics.clear();

			graphics.beginFill(0xffffff);
			graphics.drawRect(0,0,getScreenX(),getScreenY());
			graphics.endFill();

			graphics.lineStyle(3, 0x000000, 1.0, false);			
			graphics.drawRect(0,0,getScreenX(),getScreenY());
		}



		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function drawFinalBackground():void
		{

			graphics.clear();

			graphics.beginFill(0xffffff);
			graphics.drawRect(0,0,getScreenX(),getScreenY());
			graphics.endFill();


			var c:Array = new Array();
			var a:Array = new Array();
			var r:Array = new Array();

			var rand:int = Random.getInt(17);


			var yspot:int;

			if (rand == 0)
			{
				c = [1540917,15912788];
				a = [1,1];
				r = [0,127];
				yspot = 165;
			}
			else if (rand == 1)
			{
				c = [13182743,13999706];
				a = [1,1];
				r = [0,127];
				yspot = 390;
			}
			else if (rand == 2)
			{
				c = [10069333,5444756];
				a = [1,1];
				r = [0,127];
				yspot = 177;
			}
			else if (rand == 3)
			{
				c = [1748954,12815531];
				a = [1,1];
				r = [0,127];
				yspot = 228;
			}
			else if (rand == 4)
			{
				c = [9593387,11659521];
				a = [1,1];
				r = [0,127];
				yspot = 236;
			}
			else if (rand == 5)
			{
				c = [11179954,12315118];
				a = [1,1];
				r = [0,127];
				yspot = 327;
			}
			else if (rand == 6)
			{
				c = [12885134,13224153];
				a = [1,1];
				r = [0,127];
				yspot = 445;
			}
			else if (rand == 7)
			{
				c = [6179874,8198814,9725119];
				a = [1,1,1];
				r = [0,85,170];
				yspot = 317;
			}
			else if (rand == 8)
			{
				c = [14217806];
				a = [1];
				r = [0];
				yspot = 488;
			}
			else if (rand == 9)
			{
				c = [2533220,14998485];
				a = [1,1];
				r = [0,127];
				yspot = 56;
			}
			else if (rand == 10)
			{
				c = [9141830,16424253];
				a = [1,1];
				r = [0,127];
				yspot = 9;
			}
			else if (rand == 11)
			{
				c = [5036714,7855337,14221235,3008733];
				a = [1,1,1,1];
				r = [0,63,126,189];
				yspot = 151;
			}
			else if (rand == 12)
			{
				c = [6488638,13393794];
				a = [1,1];
				r = [0,127];
				yspot = 434;
			}
			else if (rand == 13)
			{
				c = [15673927,14871070];
				a = [1,1];
				r = [0,127];
				yspot = 465;
			}
			else if (rand == 14)
			{
				c = [2665622,16381871];
				a = [1,1];
				r = [0,127];
				yspot = 164;
			}
			else if (rand == 15)
			{
				c = [15017293,16410455,13144647];
				a = [1,1,1];
				r = [0,85,170];
				yspot = 421;
			}
			else //if (rand == 16)
			{
				c = [5756804,10219760];
				a = [1,1];
				r = [0,127];
				yspot = 185;
			}
 

			graphics.lineStyle(0, 0xffffff, 1.0, false);			

 
 			var mat:Matrix = new Matrix();
 			mat.createGradientBox(getScreenX() - 60,getScreenY()/1.75 - 40,1.57,0,0);	
 
 			graphics.beginGradientFill(GradientType.LINEAR,
 				       c,
 				       a,
 				       r,
 				       mat,
 				       SpreadMethod.PAD,
 				       InterpolationMethod.RGB,
 				       0.0);
 
 			graphics.drawRect(19,18,getScreenX() - 39,getScreenY()/1.75 - 38);
 			graphics.endFill();		
 	

			//draw sun
			var rad:int = Random.getInt(380) + 20;
			var rgb_r:uint;
			var rgb_g:uint;
			rgb_r = Random.getInt(55) + 200;
			rgb_g = Random.getInt(55) + 200;
			rgb_r = uint(rgb_r << 16);
			rgb_g = uint(rgb_g << 8);
			var thecol:uint = rgb_r | rgb_g;
			graphics.beginFill(thecol);
			graphics.lineStyle(0, thecol, 1.0, false);
			graphics.drawCircle(Random.getInt(getScreenX() - 40) + 20,Random.getInt(getScreenY()/1.75 - 40),rad);
			graphics.endFill();	
	
	


			//draw landscape
			var i:int = 0;
			var x1:int = 0;
			var x2:int = 0;



			for(i=0;i<5;i++)				
			{
				graphics.lineStyle(1, 0xaf5000, 1.0, false);

				rand = Random.getInt(3);
				if (rand == 0)
				{
					graphics.beginFill(0xaf5000);
				}				
				else if (rand == 1)
				{
					graphics.beginFill(0xbf6000);
				}
				else
				{
					graphics.beginFill(0xcf9000);
				}


				x1 = 0;

				x2 = x1 + (Random.getInt(getScreenX()) * 0.2);

				graphics.moveTo(x1, getScreenY()/1.75 - 20);

				while(x1 < getScreenX())
				{

					graphics.curveTo((x1 + x2)/2, (getScreenY()/1.75 - 20) - (getScreenY()*((Random.getFloat() + 0.25)*0.2)),
						      x2, 	  getScreenY()/1.75 - 20);

					x1 = x2;
					x2 = x1 + (Random.getInt(getScreenX()) * 0.8);

				}
				
				graphics.endFill();

			}
	


			//draw covering boxes for outer edges
			var bcol:uint = 0x7000a0;

			graphics.lineStyle(0, bcol, 1.0, false);			
			
			graphics.beginFill(bcol);
			graphics.drawRect(0,0,14,getScreenY());
			graphics.endFill();

			graphics.beginFill(bcol);
			graphics.drawRect(0,0,getScreenY(),14);
			graphics.endFill();

			graphics.beginFill(bcol);
			graphics.drawRect(getScreenX() - 20,0,20,getScreenY());
			graphics.endFill();

			graphics.beginFill(bcol);
			graphics.drawRect(0,getScreenY()/1.75 - 20,getScreenX(),getScreenY());
			graphics.endFill();



			graphics.lineStyle(6, 0x000000, 1.0, false);			
			graphics.drawRect(16,16,getScreenX() - 32,getScreenY()/1.75 - 33);


			graphics.lineStyle(2, 0xffffff, 1.0, false);			
			graphics.drawRect(18,18,getScreenX() - 36,getScreenY()/1.75 - 37);


			graphics.lineStyle(3, 0x000000, 1.0, false);			
			graphics.drawRect(1,1,getScreenX()-3,getScreenY()-3);
			
				
		}


		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function drawBlackBox(pos_y:int):void
		{
			graphics.moveTo(getScreenX()/2 - getScreenX()/4,pos_y);
			graphics.lineStyle(2, 0xffffff, 1.0, false);			
			graphics.beginFill(0x000000);
			graphics.drawRect(getScreenX()/2 - getScreenX()/3.8 - 1,pos_y,getScreenX()/1.9 + 1,getScreenY()/3);
			graphics.endFill();

			graphics.lineStyle(8, 0xffffff, 1.0, false);			
			graphics.beginFill(0x000000);
			graphics.drawRect(getScreenX()/2 - getScreenX()/4,pos_y,getScreenX()/2,getScreenY()/3);
			graphics.endFill();			
		}


		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function drawBackground():void
		{
		

			graphics.clear();


			var rand:int;
			
			var c:Array = new Array();
			var a:Array = new Array();
			var r:Array = new Array();
		
			var num_times:int=1;
			if (((game_level + 1) %5) == 0)
				num_times = 20;
					
			rand = Random.getInt(17);


			var yspot:int;
			
			if (rand == 0)
			{
				c = [1540917,15912788];
				a = [1,1];
				r = [0,127];
				yspot = 165;
			}
			else if (rand == 1)
			{
				c = [13182743,13999706];
				a = [1,1];
				r = [0,127];
				yspot = 390;
			}
			else if (rand == 2)
			{
				c = [10069333,5444756];
				a = [1,1];
				r = [0,127];
				yspot = 177;
			}
			else if (rand == 3)
			{
				c = [1748954,12815531];
				a = [1,1];
				r = [0,127];
				yspot = 228;
			}
			else if (rand == 4)
			{
				c = [9593387,11659521];
				a = [1,1];
				r = [0,127];
				yspot = 236;
			}
			else if (rand == 5)
			{
				c = [11179954,12315118];
				a = [1,1];
				r = [0,127];
				yspot = 327;
			}
			else if (rand == 6)
			{
				c = [12885134,13224153];
				a = [1,1];
				r = [0,127];
				yspot = 445;
			}
			else if (rand == 7)
			{
				c = [6179874,8198814,9725119];
				a = [1,1,1];
				r = [0,85,170];
				yspot = 317;
			}
			else if (rand == 8)
			{
				c = [14217806];
				a = [1];
				r = [0];
				yspot = 488;
			}
			else if (rand == 9)
			{
				c = [2533220,14998485];
				a = [1,1];
				r = [0,127];
				yspot = 56;
			}
			else if (rand == 10)
			{
				c = [9141830,16424253];
				a = [1,1];
				r = [0,127];
				yspot = 9;
			}
			else if (rand == 11)
			{
				c = [5036714,7855337,14221235,3008733];
				a = [1,1,1,1];
				r = [0,63,126,189];
				yspot = 151;
			}
			else if (rand == 12)
			{
				c = [6488638,13393794];
				a = [1,1];
				r = [0,127];
				yspot = 434;
			}
			else if (rand == 13)
			{
				c = [15673927,14871070];
				a = [1,1];
				r = [0,127];
				yspot = 465;
			}
			else if (rand == 14)
			{
				c = [2665622,16381871];
				a = [1,1];
				r = [0,127];
				yspot = 164;
			}
			else if (rand == 15)
			{
				c = [15017293,16410455,13144647];
				a = [1,1,1];
				r = [0,85,170];
				yspot = 421;
			}
			else //if (rand == 16)
			{
				c = [5756804,10219760];
				a = [1,1];
				r = [0,127];
				yspot = 185;
			}
			
		
			if (num_times != 1)
			{
				c = [0x000090,0x400030];
				a = [1,1];
				r = [0,127];
				yspot = 185;
			}
		
			var mat:Matrix = new Matrix();
			mat.createGradientBox(getScreenX(),getScreenY()/2,1.57,0,0);	

			graphics.beginGradientFill(GradientType.LINEAR,
				       c,
				       a,
				       r,
				       mat,
				       SpreadMethod.PAD,
				       InterpolationMethod.RGB,
				       0.0);

			graphics.drawRect(0,0,getScreenX(),getScreenY());
			graphics.endFill();		
	



			var rad:int;
			var rgb_r:uint;
			var rgb_g:uint;
			var rgb_b:uint;
			var thecol:uint;

		
			for(i=0;i<num_times;i++)
			{
				//draw sun
				if (num_times > 1)
				{
					rad = Random.getInt(2) + 1;
					rgb_r = Random.getInt(100) + 155;
					rgb_g = Random.getInt(100) + 155;
					rgb_b = Random.getInt(100) + 155;

					rgb_r = uint(rgb_r << 16);
					rgb_g = uint(rgb_g << 8);
					thecol = rgb_r | rgb_g | rgb_b;

				}
				else
				{
					rad = Random.getInt(380) + 20;
					rgb_r = Random.getInt(55) + 200;
					rgb_g = Random.getInt(55) + 200;
					rgb_r = uint(rgb_r << 16);
					rgb_g = uint(rgb_g << 8);
					thecol = rgb_r | rgb_g;
				}
				
				graphics.beginFill(thecol);
				graphics.lineStyle(0, thecol, 1.0, false);
				graphics.drawCircle(Random.getInt(getScreenX()),Random.getInt(getScreenY()),rad);
				graphics.endFill();		
			}



			//draw landscape
			var i:int = 0;
			var x1:int = 0;
			var x2:int = 0;


			for(i=0;i<5;i++)				
			{
				graphics.lineStyle(1, 0xaf5000, 1.0, false);

				rand = Random.getInt(3);
				if (rand == 0)
				{
					graphics.beginFill(0xaf5000);
				}				
				else if (rand == 1)
				{
					graphics.beginFill(0xbf6000);
				}
				else
				{
					graphics.beginFill(0xcf9000);
				}


				x1 = 0;

				x2 = x1 + (Random.getInt(getScreenX()) * 0.2);

				graphics.moveTo(x1, getScreenY());

				while(x1 < getScreenX())
				{

					graphics.curveTo((x1 + x2)/2, getScreenY() - (getScreenY()*((Random.getFloat() + 0.25)*0.2)),
						      x2, 	  getScreenY());

					x1 = x2;
					x2 = x1 + (Random.getInt(getScreenX()) * 0.8);

				}

				graphics.endFill();


			}





	




			//draw bottom border
			graphics.lineStyle(6, 0x055000, 1.0, false);
			graphics.lineTo(getScreenX(),getScreenY()-3);
			graphics.lineTo(0,getScreenY()-3);


			//draw side walls for bins
			graphics.lineStyle(10, 0x055000, 1.0, false);
			graphics.moveTo(5,getScreenY()/1.9);
			graphics.lineTo(5,getScreenY()-5);
			graphics.moveTo(getScreenX() - 5,getScreenY()/1.9);
			graphics.lineTo(getScreenX() - 5,getScreenY()-5);



			//draw mechanic rails
			graphics.lineStyle(16, 0x400040, 1.0, false);
			graphics.moveTo(8,getScreenY()/1.9);
			graphics.lineTo(8,8);
			graphics.lineTo(getScreenX() - 8,8);
			graphics.lineTo(getScreenX() - 8,getScreenY()/1.9);

			graphics.lineStyle(3, 0x800080, 1.0, false);
			graphics.moveTo(4,getScreenY()/1.9);
			graphics.lineTo(4,4);
			graphics.lineTo(getScreenX() - 4,4);
			graphics.lineTo(getScreenX() - 4,getScreenY()/1.9);

			graphics.lineStyle(3, 0x800080, 1.0, false);
			graphics.moveTo(12,getScreenY()/1.9);
			graphics.lineTo(12,12);
			graphics.lineTo(getScreenX() - 12,12);
			graphics.lineTo(getScreenX() - 12,getScreenY()/1.9);

			graphics.lineStyle(1, 0x0000ff, 1.0, false);
			graphics.moveTo(8,getScreenY()/1.9);
			graphics.lineTo(8,8);
			graphics.lineTo(getScreenX() - 8,8);
			graphics.lineTo(getScreenX() - 8,getScreenY()/1.9);


			
		}

	}

}

