


////////////////////////////////////////////////////////////////////////
//
//
//
////////////////////////////////////////////////////////////////////////


package
{

	include "ImportFile.as"


	public class DoomsdayInner extends GameObj
	{

		private var glow_active:Boolean = false;

		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public function DoomsdayInner(game:Game, pobj:Sprite, pos:Point, in_size:Point)
		{
			//call super constructor
			super(game,pobj, pos,in_size,GameObj.FLAG_DISPLAYABLE,0,0);

		}
		
		
		

		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public override function shutdown():void
		{
			filters = new Array();	
			super.shutdown();
		}

		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public function activateGlow():void
		{
			if (glow_active == true)
				return;
				
			glow_active = true;
			draw();
		}
		


		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public function decactivateGlow():void
		{
			glow_active = false;
		}
		


		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public override function draw():void
		{

			graphics.clear();

			var mat:Matrix = new Matrix();
			mat.createGradientBox(size.x/2,size.y/2,0.0,0,0);	

			var c:Array = new Array();
			var a:Array = new Array();
			var r:Array = new Array();

			a = [1,1];
			r = [0,255];
			c = [0x9000e0,0x2000d0];
			graphics.beginGradientFill(GradientType.LINEAR,
							c,
							a,
							r,
							mat,
							SpreadMethod.PAD,
							InterpolationMethod.RGB,
							0.0);

			graphics.drawCircle(0,0,size.x);
			graphics.endFill();

			if (glow_active)
			{
				//draw the glow part
				var filter:BitmapFilter = getBitmapFilter();
				var myFilters:Array = new Array();
				myFilters.push(filter);
				filters = myFilters;
			}
			else
			{
				filters = new Array();
			}
		}


		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		private function getBitmapFilter():BitmapFilter
		{
			var color:Number = 0xffff00;

			var alpha:Number = 0.8;
			var blurX:Number = 35;
			var blurY:Number = 35;
			var strength:Number = 3;
			var inner:Boolean = false;
			var knockout:Boolean = false;
			var quality:Number = BitmapFilterQuality.LOW;

			return new GlowFilter(color,
					  alpha,
					  blurX,
					  blurY,
					  strength,
					  quality,
					  inner,
					  knockout);
		}


	
	}
}