	

///////////////////////////////////////////////////////////////////////
//
// and egg is dropped from a bud that was shot in the air
//
////////////////////////////////////////////////////////////////////////


package 
{

	include "ImportFile.as"


	public class Egg extends GameObj
	{

		private var type:int;

		public static const TYPE_GROW_FLOWER:uint = 0;		
		public static const TYPE_GROW_ALL:uint    = 1;		
		public static const TYPE_MAX:uint         = 2;		

		private var energy:int = 1;

	
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function Egg(game:Game, pobj:Sprite, x:int, y:int)
		{
			//set coll info
			var coll_cat:uint = CollInfo.COLL_CATEGORY_EGG;
			var coll_mask:uint = CollInfo.COLL_CATEGORY_BAR;

			//select a random type for this egg
			if (Random.getInt(10) < 1)
				this.type = TYPE_GROW_ALL;
			else
				this.type = TYPE_GROW_FLOWER;

			var flags:uint = GameObj.FLAG_DISPLAYABLE |  GameObj.FLAG_COLLIDABLE;

			//call super constructor
			super(game, pobj, new Point(x, y), new Point(25, 25),flags,coll_cat, coll_mask);
			
		}



		////////////////////////////////////////////////////////////////////////
		//
		// 
		//
		////////////////////////////////////////////////////////////////////////
		public override function update(time_diff:int):void
		{
	
			super.update(time_diff);
	
			//delete egg if it's gone off the bottom of the screen 
			//this happens when the player doesn't catch it
			if (y > (game.getScreenY() + size.y))
				delete_me = true;
					
		}



		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public override function draw():void
		{

			graphics.clear();

			if (this.type == TYPE_GROW_FLOWER)
			{
				graphics.lineStyle(3, 0xffffff, 1.0, false);
				graphics.beginFill(0x00aa00);
				graphics.drawCircle(0,0,size.x);
				graphics.endFill();			

				graphics.lineStyle(3, 0x008000, 1.0, false);
				graphics.beginFill(0x00aa00);
				graphics.drawCircle(0,0,size.x*0.7);
				graphics.endFill();			

				graphics.lineStyle(10, 0xffffff, 1.0, false);
				graphics.moveTo(-size.x*0.4,0);
				graphics.lineTo(+size.x*0.4,0);			

				graphics.moveTo(0,-size.y*0.4);
				graphics.lineTo(0,size.y*0.4);			

			}
			else if (this.type == TYPE_GROW_ALL)
			{
				graphics.lineStyle(3, 0xffffff, 1.0, false);
				graphics.beginFill(0x00aa00);
				graphics.drawCircle(0,0,size.x);
				graphics.endFill();			

				graphics.lineStyle(3, 0x008000, 1.0, false);
				graphics.beginFill(0x00aa00);
				graphics.drawCircle(0,0,size.x*0.7);
				graphics.endFill();			

				graphics.lineStyle(2,0xffffff , 1.0, false);
				graphics.beginFill(0xffffff);
				graphics.drawCircle(0,0,size.x*0.4);
				graphics.endFill();						
			}

		}
		
		

		////////////////////////////////////////////////////////////////////////
		//
		// 
		//
		////////////////////////////////////////////////////////////////////////
		public function getType():int { return type; }
		public function getEnergy():int { return energy; }
		public function clearEnergy():void { energy = 0; }

		

	}
}