

////////////////////////////////////////////////////////////////////////
//
// 
//
////////////////////////////////////////////////////////////////////////


package
{

	include "ImportFile.as"

	public class GameSounds
	{

		//embedded sounds
		[Embed(source="../snd/Music1.mp3")]
		private static var Music1:Class;
		[Embed(source="../snd/Music2.mp3")]
		private static var Music2:Class;


		[Embed(source="../snd/Final.mp3")]
		private static var Final:Class;


		[Embed(source="../snd/Cheer1.mp3")]
		private static var Cheer1:Class;

		[Embed(source="../snd/Cheer2.mp3")]
		private static var Cheer2:Class;

		[Embed(source="../snd/LevelEnd.mp3")]
		private static var LevelEnd:Class;

			
		[Embed(source="../snd/BallIn.mp3")]
		private static var BallIn:Class;

	
		[Embed(source="../snd/Buds.mp3")]
		private static var Buds:Class;

		[Embed(source="../snd/Killer.mp3")]
		private static var Killer:Class;

		[Embed(source="../snd/Upgrade.mp3")]
		private static var Upgrade:Class;

		[Embed(source="../snd/BallHitBar.mp3")]
		private static var BallHitBar:Class;

		[Embed(source="../snd/BallHitBarrier1.mp3")]
		private static var BallHitBarrier1:Class;
		[Embed(source="../snd/BallHitBarrier2.mp3")]
		private static var BallHitBarrier2:Class;

		[Embed(source="../snd/FlowerHit1.mp3")]
		private static var FlowerHit1:Class;

		[Embed(source="../snd/FlowerHit2.mp3")]
		private static var FlowerHit2:Class;

		[Embed(source="../snd/FlowerHit3.mp3")]
		private static var FlowerHit3:Class;


		public static const TYPE_MUSIC1:int		= 0;
		public static const TYPE_MUSIC2:int		= 1;
		public static const TYPE_MUSIC_CHEER:int 	= 2;
		public static const TYPE_MUSIC_LEVELEND:int 	= 3;
		public static const TYPE_MUSIC_FINAL:int 	= 4;

		private static var music1:Sound;
		private static var music2:Sound;

		private static var levelend:Sound;
		private static var cheer1:Sound;
		private static var cheer2:Sound;
		private static var final:Sound;

		private static var ballin:Sound;
		private static var killer:Sound;
		private static var buds:Sound;
		private static var upgrade:Sound;
		private static var ballhitbar:Sound;
		private static var ballhitbarrier1:Sound;
		private static var ballhitbarrier2:Sound;
		private static var flowerhit1:Sound;
		private static var flowerhit2:Sound;
		private static var flowerhit3:Sound;

		private	static var channel_music:SoundChannel = new SoundChannel();
		private	static var channel_ballin:SoundChannel = new SoundChannel();
		private	static var channel_bud:SoundChannel = new SoundChannel();
		private	static var channel_ballhitbar:SoundChannel = new SoundChannel();
		private	static var channel_ballhitbarrier:SoundChannel = new SoundChannel();
		private	static var channel_upgrade:SoundChannel = new SoundChannel();
		private	static var channel_killer:SoundChannel = new SoundChannel();
		private	static var channel_danger:SoundChannel = new SoundChannel();
		private	static var channel_flowerhit:SoundChannel = new SoundChannel();
		

		private static var transform_music:SoundTransform = new SoundTransform(0.125);
		private static var transform_fx:SoundTransform = new SoundTransform(0.25);
		
		
		public static const VOL_0:int		= 0;
		public static const VOL_1:int		= 1;
		public static const VOL_2:int		= 2;
		public static const VOL_3:int		= 3;

		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public static function setSoundLevel(lev:int):void
		{
			if (lev == VOL_0)
			{
				transform_music = new SoundTransform(0.0);
				transform_fx = new SoundTransform(0.0);
			}
			else if (lev == VOL_1)
			{
				transform_music = new SoundTransform(0.05);
				transform_fx = new SoundTransform(0.1);
			}
			else if (lev == VOL_2)
			{
				transform_music = new SoundTransform(0.125);
				transform_fx = new SoundTransform(0.25);
			}
			else //if (lev == VOL_3)
			{
				transform_music = new SoundTransform(0.25);
				transform_fx = new SoundTransform(0.5);
			}
			
			//reapply to all channels
			if (channel_music)
				channel_music.soundTransform = transform_music;
			if (channel_ballin)
				channel_ballin.soundTransform = transform_fx;
			if (channel_bud)
				channel_bud.soundTransform = transform_fx;
			if (channel_ballhitbar)
				channel_ballhitbar.soundTransform = transform_fx;
			if (channel_ballhitbarrier)
				channel_ballhitbarrier.soundTransform = transform_fx;
			if (channel_upgrade)
				channel_upgrade.soundTransform = transform_fx;
			if (channel_killer)
				channel_killer.soundTransform = transform_fx;
			if (channel_danger)
				channel_danger.soundTransform = transform_fx;
			if (channel_flowerhit)
				channel_flowerhit.soundTransform = transform_fx;
		}
		

		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public static function init():void
		{

			music1 = new Music1();
			music2 = new Music2();

			levelend = new LevelEnd();
			cheer1 = new Cheer1();
			cheer2 = new Cheer2();
			final = new Final();

			ballin = new BallIn();
			ballhitbar = new BallHitBar();
			ballhitbarrier1 = new BallHitBarrier1();
			ballhitbarrier2 = new BallHitBarrier2();
			flowerhit1 = new FlowerHit1();
			flowerhit2 = new FlowerHit2();
			flowerhit3 = new FlowerHit3();
			buds = new Buds();
			upgrade = new Upgrade();
			killer = new Killer();


		}			


		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public static function shutdown():void
		{
		}
		
		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public static function playMusic(type:int):void
		{
			channel_music.stop();	

						
			if (type == TYPE_MUSIC1)
			{
				channel_music = music1.play(0,99999999,transform_music);
				
			}
			else if (type == TYPE_MUSIC2)
			{
				channel_music = music2.play(0,99999999,transform_music);
				
			}
			else if (type == TYPE_MUSIC_CHEER)
			{
				if (Random.getInt(2) == 0)
					channel_music = cheer1.play(0,0,transform_music);
				else
					channel_music = cheer2.play(0,0,transform_music);

			}
			else if (type == TYPE_MUSIC_LEVELEND)
			{
				channel_music = levelend.play(0,0,transform_music);
			}
			else //if (type == TYPE_MUSIC_FINAL)
			{
				channel_music = final.play(0,0,transform_music);
			}


		}


		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public static function playBud():void
		{
			channel_bud.stop();	
			channel_bud = buds.play(0,0,transform_fx);

		}

		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public static function playKiller():void
		{
			channel_killer.stop();	
			channel_killer = killer.play(0,0,transform_fx);

		}


		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public static function playDanger():void
		{
			channel_killer.stop();	
			channel_killer = killer.play(0,3,transform_fx);
		}


		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public static function playUpgrade():void
		{
			channel_upgrade.stop();	
			channel_upgrade = upgrade.play(0,0,transform_fx);

		}


		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public static function playBallHitBar():void
		{
			channel_ballhitbar.stop();	
			channel_ballhitbar = ballhitbar.play(0,0,transform_fx);

		}


		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public static function playBallHitBarrier():void
		{
			channel_ballhitbarrier.stop();	
			
			if (Random.getInt(2) == 0)
				channel_ballhitbarrier = ballhitbarrier1.play(0,0,transform_fx);
			else			
				channel_ballhitbarrier = ballhitbarrier2.play(0,0,transform_fx);
			
		}

		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public static function playFlowerHit():void
		{
			channel_flowerhit.stop();	

			var rand:int = Random.getInt(3);	
			
			if (rand == 0)
				channel_flowerhit = flowerhit1.play(0,0,transform_fx);
			else if (rand == 1)
				channel_flowerhit = flowerhit2.play(0,0,transform_fx);
			else //
				channel_flowerhit = flowerhit3.play(0,0,transform_fx);
			
		}


		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public static function playBallIn():void
		{
			channel_ballin.stop();	
			channel_ballin = ballin.play(0,0,transform_fx);

		}

	}
}
