

///////////////////////////////////////////////////////////////////////
//
// 
//
////////////////////////////////////////////////////////////////////////





package 
{
	include "ImportFile.as"


	public class GameStateIntro extends GameState
	{

		private var text_format_big:TextFormat;
	
		private var info:TextField = null;
		private var clickme:TextField = null;
		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function GameStateIntro(game:Cabol)
		{

			var text_format_small:TextFormat;


			//call super const
			super(game);
		
			//draw background for 
			((Cabol)(game)).drawLoadingBackground();		

			//create small text format
			text_format_small = new TextFormat();
			text_format_small.color = 0x0000ff;
			text_format_small.size = 20;
			text_format_small.font = "foo";

			//create large text format
			text_format_big = new TextFormat();
			text_format_big.color = 0x0000ff;
			text_format_big.size = 30;
			text_format_big.font = "foo";


			
			//create and add info field			
			info = new TextField();
			info.x = 10;
			info.y = 10;
			info.width = game.getScreenX();
			info.height = game.getScreenY();
			info.text="CABOL\nby enup games\n\nprotect flowers from bouncing balls\n\nknock balls into green bins to make flowers grow\n\nclick button to make bar rotate\n\ndouble-click on doomsday device (at top of screen) to change bar rotation\n\nhit doomsday device with a ball to reset it";
			info.wordWrap = true;
			info.setTextFormat(text_format_small);
			info.embedFonts = true;
			info.defaultTextFormat = text_format_small;
			game.addChild(info);

			//create and add clickme field
			clickme = new TextField();
			clickme.setTextFormat(text_format_big);
			clickme.embedFonts = true;
			clickme.defaultTextFormat = text_format_big;
			clickme.x = 10;
			clickme.y = 430;
			clickme.width = game.getScreenX();
			clickme.height = game.getScreenY();
			clickme.text = "CLICK TO START";
			game.addChild(clickme);

			//add listener for click
			game.getStage().addEventListener(MouseEvent.MOUSE_UP, setClicked);
			
					
		}



		////////////////////////////////////////////////////////////////////////
		//
		// 
		//
		////////////////////////////////////////////////////////////////////////
		public override function shutdown():void
		{
			game.getStage().removeEventListener(MouseEvent.MOUSE_UP, setClicked);

			game.removeChild(clickme);
			game.removeChild(info);

			super.shutdown();
			
		}


		////////////////////////////////////////////////////////////////////////
		//
		// 
		//
		////////////////////////////////////////////////////////////////////////
		public override function go():void
		{			
			super.go();

			//color flash the 'click me' sign	
			text_format_big.color = Random.getInt(16777215);
			clickme.setTextFormat(text_format_big);

	
		}


		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		private function setClicked(event:Event):void 
		{
			game.setGameState(Cabol.GAME_STATE_PLAY);
		}
		
				
	}
}