

///////////////////////////////////////////////////////////////////////
//
// 
//
////////////////////////////////////////////////////////////////////////


package 
{

	include "ImportFile.as"



	public class GameStatePlay extends GameState
	{

		//special pointer to major items
		private var game_bar:Bar;
		private var flower:Flower;

		private var game_obj_list:Array;

		
		
		public static const WIN_EFFECT_TIME:int = 120; 
		private var win_effect:int;

		public static const LOSE_EFFECT_TIME:int = 120;		
		private var lose_effect:int;

		private var lose_textfield1:TextField;
		private var lose_textfield2:TextField;
		private var lose_textfield3:TextField;


		private var win_text_format1:TextFormat;
		private var win_text_format2:TextFormat;
		private var win_text_format3:TextFormat;
		private var win_textfield1:TextField;
		private var win_textfield2:TextField;
		private var win_textfield3:TextField;

	

		private var wow_list:Array = new Array("good job!",
						       "holy moly!",
						       "golly my bolly!",
						       "great!",
						       "unbelievable!",
						       "stupendous!",
						       "zhara zhara!",
						       "pretty fancy!",
						       "yeah baby!",
						       "are yaar!",
						       "whogadabada!",
						       "zappo!",
						       "la boomba!",
						       "supa dupa!",
						       "no way!",
						       "you rock!",
						       "hey circuit!",
						       "time pass!",
						       "rockin!",
						       "potty candy!",
						       "dude!",
						       "horn OK please!",
						       "ok tata!",
						       "dard-e-disco!",
						       "wowee!",
						       "ooda booda!",
						       "woah!",
						       "omg!",
						       "amazing!",
						       "awesome!",
						       "hot!",
						       "poppin!",
						       "you gardener!",
						       "please stop!",
						       "you too much!",
						       "come na!",
						       "bale bale!",
						       "ayah!",
						       "chalo!",
						       "kitty party!",
						       "zoiks!",
						       "meep meep!",
						       "snarky!",
						       "zing!",
						       "so zygomatic!",
						       "ooshie!",
						       "doma doma!",
						       "zamboni!",
						       "is it possible?",
						       "wow!",
						       ":)",
						       "2bctnd!",
						       "2Ht2Hndl",
						       "fyi!",
						       "gosh!",
						       "j4f!",
						       "ruok?",
						       ":-)",
						       "[:-)",
						       "{:-)",
						       ";)",
						       "PAW",
						       "THX",
						       "blossom!",
						       "petalacious!",
						       "rosy!",
						       "you da style!",
						       "nectar city!",
						       "pollination!",
						       "fancy floral!",
						       "marigold mary!",
						       "yowsa!",
						       "sow dem seeds!",
						       "smells good!",
						       "pretty poppy!",
						       "botanical!",
						       "cool");

			
		private var flower_died:Boolean;	

		private	var sound_flag_ballin_cnt:int = 0;
		private	var sound_flag_ballhitbar_cnt:int = 0;
		private	var sound_flag_ballhitbarrier_cnt:int = 0;
		private	var sound_flag_ballhitflower_cnt:int = 0;

		private var allow_coll:Boolean = true;
			
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function GameStatePlay(game:Cabol)
		{

			((Cabol)(game)).initCollSystem();


			super(game);

			initGameObjs();		
			
			var temp:int = ((Cabol)(game)).getGameLevel();
			temp++;
			
			if (temp%5 == 0)
				GameSounds.playMusic(GameSounds.TYPE_MUSIC2);
			else
				GameSounds.playMusic(GameSounds.TYPE_MUSIC1);
			
			((Cabol)(game)).drawBackground();
			
			win_effect = WIN_EFFECT_TIME;
			lose_effect = LOSE_EFFECT_TIME;
			
			flower_died = false;
			
		}




		////////////////////////////////////////////////////////////////////////
		//
		// 
		//
		////////////////////////////////////////////////////////////////////////
		public override function shutdown():void
		{


			shutdownGameObjs();
		
			super.shutdown();

			((Cabol)(game)).shutdownCollSystem();

		}

	
	

		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		private function initGameObjs():void
		{

			var gobj:GameObj;
			var size_obj:Point = new Point();
			var flags:uint;
			
			
			var lev:int = ((Cabol)(game)).getGameLevel();			
			
			//init game obj list
			game_obj_list = new Array();

			//add player bar
			game_bar = new Bar(game, game,game.getScreenX()/2, game.getScreenY() - (20 * 20),this,0.0);
			gameObjListAdd(game_bar);


			//create 4 outer walls
			var actual_wall_size:int = 10;
			size_obj.x = 10;
			size_obj.y = game.getScreenY();
			flags = GameObj.FLAG_COLLIDABLE_SOLID;



			size_obj.x = 500;
			size_obj.y = game.getScreenY() * 2;
			gobj = new Barrier(game,game,new Point(0 + size_obj.x/2 - (size_obj.x - actual_wall_size),game.getScreenY()/2), new Point(size_obj.x, size_obj.y),flags,true,Barrier.TYPE_REG);
			gameObjListAdd(gobj);
			gobj = new Barrier(game,game,new Point(game.getScreenX() - size_obj.x/2 + (size_obj.x - actual_wall_size),game.getScreenY()/2), new Point(size_obj.x, size_obj.y),flags,true,Barrier.TYPE_REG);
			gameObjListAdd(gobj);

			size_obj.x = game.getScreenX() * 2;
			size_obj.y = 500;

			gobj = new Barrier(game,game,new Point(game.getScreenX()/2,0 + size_obj.y/2 - (size_obj.y - actual_wall_size)),new Point( size_obj.x, size_obj.y),flags,true,Barrier.TYPE_REG);
			gameObjListAdd(gobj);

			gobj = new Barrier(game,game,new Point(game.getScreenX()/2,game.getScreenY() - size_obj.y/2 + (size_obj.y - actual_wall_size)), new Point(size_obj.x, size_obj.y),flags,true,Barrier.TYPE_REG);
			gameObjListAdd(gobj);
			
			
			

			generateLevelBarriers(lev);




			//create bins 	
			size_obj.x = 140 - (lev * 5);
			if (size_obj.x < 80)
			{
				size_obj.x = 80;
			}

			if ((lev+1)%5 == 0)
				size_obj.x = 70;


			size_obj.y = 125;

			flags = GameObj.FLAG_DISPLAYABLE;
			gobj = new Bin(game, game, new Point(actual_wall_size + ((size_obj.x)/2), game.getScreenY() - size_obj.y/2 - actual_wall_size + 7), new Point(size_obj.x, size_obj.y),flags);
			gameObjListAdd(gobj);
			gobj = new Bin(game, game, new Point((game.getScreenX() - size_obj.x/2) - actual_wall_size, game.getScreenY() - size_obj.y/2 - actual_wall_size + 7), new Point(size_obj.x, size_obj.y),flags);
			gameObjListAdd(gobj);


			generateLevelMechanix(lev);

			//add flower				
			size_obj.x = 5;
			size_obj.y = 5;
			flower = new Flower(game, game, new Point(game.getScreenX()/2, game.getScreenY() - (size_obj.y/2 * 15)),new Point(size_obj.x,size_obj.y),this,null,true,true);
			gameObjListAdd(flower);

			//add doomsday
			size_obj.x = 30;
			size_obj.y = 30;
			//calc time based on game level
			//1st five levels get 60 seconds, after that is starts moving towards 15 seconds
			var secs:int = 60;
			if (lev >= 5)
			{
				secs = 60 - ((lev - 5) * 5);
				if (secs < 15)
					secs = 15;
			}

			gobj = new Doomsday(game, game, new Point(game.getScreenX()/2, -5 + size_obj.y/2), new Point( size_obj.x, size_obj.y),secs,this);
			gameObjListAdd(gobj);
		}
		


		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		private function shutdownGameObjs():void
		{
			var i:int;

			//loop through all objs on game obj list and destroy them
			for (i = game_obj_list.length - 1; i >= 0; i--)
			{
				game_obj_list[i].shutdown();
				gameObjListRemove(game_obj_list[i]);
			}

			game_obj_list = null;

		}




		////////////////////////////////////////////////////////////////////////
		//
		// 
		//
		////////////////////////////////////////////////////////////////////////
		public override function go():void
		{

			
			var i:int;
			var temp_flower:Flower;
			var temp_bar:Bar;
			var temp_barrier:Barrier;
			var temp_doomsday:Doomsday;
			var temp_mechanix:Mechanix;
			var v:b2Vec2;
			var vel:Point;

			//call parents go method			
			super.go();


			//check if player beat level
			if (flower.isFullyGrown())
			{

				//this is needed to make sure no balls hit the flower after flower is fully grown
				//i just turned off colls (which is gonna run after this code)
				allow_coll = false;
			
				var txt_flower:String;
				var thenum:int;

		
				if (win_effect == WIN_EFFECT_TIME)
				{


					//add flower info to flower array
					((Cabol)(game)).array_flower_info.push(flower.flower_info);
					
					GameSounds.playMusic(GameSounds.TYPE_MUSIC_CHEER);

					((Cabol)(game)).incGameLevel();
			
					((Cabol)(game)).drawBlackBox(game.getScreenY()/12);

					//destroy all objects that could hurt your flower
					//balls, doomsday, mechanics
					for (i = game_obj_list.length-1; i >-1;i--)
					{
						if (game_obj_list[i] is Ball ||
						    game_obj_list[i] is Mechanix ||
						    game_obj_list[i] is Doomsday ||
						    game_obj_list[i] is Bud ||
						    game_obj_list[i] is Egg ||
						    game_obj_list[i] is Barrier ||
						    game_obj_list[i] is Bar)
						{
							game_obj_list[i].setForDelete();
						}
					}
					
					
					//add text
					win_text_format1 = new TextFormat();
					win_text_format1.color = 0x00b000;
					win_text_format1.size = 30;
					win_text_format1.align='center';
					win_text_format1.font = "foo";


					win_text_format2 = new TextFormat();
					win_text_format2.color = 0x00b000;
					win_text_format2.size = 20;
					win_text_format2.align='center';
					win_text_format2.font = "foo";

					win_text_format3 = new TextFormat();
					win_text_format3.color = 0xffffff;
					win_text_format3.size = 40;
					win_text_format3.align='center';
					win_text_format3.font = "foo";

					win_textfield1 = new TextField();
					win_textfield1.setTextFormat(win_text_format1);
					win_textfield1.defaultTextFormat = win_text_format1;
					win_textfield1.x = 0;
					win_textfield1.y = game.getScreenY()/10;
					win_textfield1.width = game.getScreenX();
					win_textfield1.height = game.getScreenY();
					win_textfield1.text = getWow();
					win_textfield1.embedFonts = true;

					win_textfield2 = new TextField();
					win_textfield2.setTextFormat(win_text_format2);
					win_textfield2.defaultTextFormat = win_text_format2;
					win_textfield2.x = 0;
					win_textfield2.y = game.getScreenY()/10 - 5;
					win_textfield2.width = game.getScreenX();
					win_textfield2.height = game.getScreenY();
					win_textfield2.embedFonts = true;

					if (((Cabol)(game)).array_flower_info.length == 1)
						txt_flower = "flower";
					else 
						txt_flower = "flowers";
					win_textfield2.text = "\n\nyou've grown\n\n\n" + txt_flower + "!"	


					win_textfield3 = new TextField();
					win_textfield3.setTextFormat(win_text_format3);
					win_textfield3.defaultTextFormat = win_text_format3;
					win_textfield3.x = 0;
					win_textfield3.y = game.getScreenY()/10 + 25;
					win_textfield3.width = game.getScreenX();
					win_textfield3.height = game.getScreenY();
					thenum = ((Cabol)(game)).array_flower_info.length;
					win_textfield3.text = "\n" + thenum;
					win_textfield3.embedFonts = true;

					
					game.addChild(win_textfield1);
					game.addChild(win_textfield2);
					game.addChild(win_textfield3);

				}


				if (win_effect % 4 == 0)
				{
					win_text_format1.color = Random.getInt(16777215);
					win_textfield1.setTextFormat(win_text_format1);
				}				
				
				win_effect--;
				if (win_effect <= 0)
				{
					game.removeChild(win_textfield1);
					game.removeChild(win_textfield2);
					game.removeChild(win_textfield3);

					game.setGameState(Cabol.GAME_STATE_PLAY);				
					return;
				}

			}
			else if (flower.isDead()) // check if player lost
			{

		
				if (lose_effect == LOSE_EFFECT_TIME)
				{
					flower_died = true;

					GameSounds.playMusic(GameSounds.TYPE_MUSIC_LEVELEND);

					
					((Cabol)(game)).drawBlackBox(game.getScreenY() - game.getScreenY()/2.5);

					//destroy all objects that could hurt your flower
					//balls, doomsday, mechanics
					for (i = game_obj_list.length-1; i >-1;i--)
					{
						if (game_obj_list[i] is Ball ||
						    game_obj_list[i] is Mechanix ||
						    game_obj_list[i] is Doomsday ||
						    game_obj_list[i] is Bud ||
						    game_obj_list[i] is Egg ||
						    game_obj_list[i] is Barrier ||
						    game_obj_list[i] is Bar ||
						    game_obj_list[i] is Flower)
						{
							game_obj_list[i].setForDelete();
						}
					}

					win_text_format1 = new TextFormat();
					win_text_format1.color = 0x00b000;
					win_text_format1.size = 30;
					win_text_format1.align='center';
					win_text_format1.font = "foo";


					win_text_format2 = new TextFormat();
					win_text_format2.color = 0x00b000;
					win_text_format2.size = 20;
					win_text_format2.align='center';
					win_text_format2.font = "foo";

					win_text_format3 = new TextFormat();
					win_text_format3.color = 0xffffff;
					win_text_format3.size = 40;
					win_text_format3.align='center';
					win_text_format3.font = "foo";

					
					//add text
					lose_textfield1 = new TextField();
					lose_textfield1.setTextFormat(win_text_format1);
					lose_textfield1.defaultTextFormat = win_text_format1;
					lose_textfield1.x = 0;
					lose_textfield1.y = game.getScreenY() - game.getScreenY()/2.5 + 7;
					lose_textfield1.width = game.getScreenX();
					lose_textfield1.height = game.getScreenY();
					lose_textfield1.text = "OUCH!";
					lose_textfield1.embedFonts = true;

					lose_textfield2 = new TextField();
					lose_textfield2.setTextFormat(win_text_format2);
					lose_textfield2.defaultTextFormat = win_text_format2;
					lose_textfield2.x = 0;
					lose_textfield2.y = game.getScreenY() - game.getScreenY()/2.5 - 10;
					lose_textfield2.width = game.getScreenX();
					lose_textfield2.height = game.getScreenY();
					lose_textfield2.embedFonts = true;

					if (((Cabol)(game)).array_flower_info.length == 1)
						txt_flower = "flower";
					else 
						txt_flower = "flowers";
					lose_textfield2.text = "\n\nYou grew\n\n\n" + txt_flower + "!"	


					lose_textfield3 = new TextField();
					lose_textfield3.setTextFormat(win_text_format3);
					lose_textfield3.defaultTextFormat = win_text_format3;
					lose_textfield3.x = 0;
					lose_textfield3.y = game.getScreenY() - game.getScreenY()/2.5 + 20;
					lose_textfield3.width = game.getScreenX();
					lose_textfield3.height = game.getScreenY();
					thenum = ((Cabol)(game)).array_flower_info.length	;
					lose_textfield3.text = "\n" + thenum;
					lose_textfield3.embedFonts = true;

					
					game.addChild(lose_textfield1);
					game.addChild(lose_textfield2);
					game.addChild(lose_textfield3);

				}


				if (lose_effect % 4 == 0)
				{
					win_text_format1.color = Random.getInt(16777215);
					lose_textfield1.setTextFormat(win_text_format1);
				}				
				
				lose_effect--;
				if (lose_effect <= 0)
				{
					game.removeChild(lose_textfield1);
					game.removeChild(lose_textfield2);
					game.removeChild(lose_textfield3);

					game.setGameState(Cabol.GAME_STATE_FINAL);				
					return;
				}

			}
			
			//remove any objects that are flagged to be deleted	
			for (i = game_obj_list.length-1; i >-1;i--)
			{
				if (game_obj_list[i].deleteMe() == true)
				{
					game_obj_list[i].shutdown();
					gameObjListRemove(game_obj_list[i]);
				}
			}



			//do updates 
			for (i = 0; i < game_obj_list.length; i++)
				game_obj_list[i].update(game.getTimeDiff());
							

			var sound_flag_ballin:Boolean = false;
			var sound_flag_ballhitbar:Boolean = false;
			var sound_flag_ballhitbarrier:Boolean = false;
			var sound_flag_ballhitflower:Boolean = false;


			if (allow_coll)
			{

				var shp:b2Shape;
				var cbody:b2Body;

				//dealing with collisions of objects			
				for (var c:b2Contact = game.getCollSystem().getContactList() ; c ; c = c.GetNext())
				{            
					// A positive manifold count ensures that the shapes are actually touching.
					if (c.GetManifoldCount() > 0)
					{
						var body1: b2Body = c.GetShape1().GetBody();
						var body2: b2Body = c.GetShape2().GetBody();


						var obj1:Object = body1.GetUserData();
						var obj2:Object = body2.GetUserData();


						if (obj1 is Ball)
						{

							//get 1st shape of obj2's coll body
							cbody = body2;
							shp = cbody.GetShapeList();

							//NOTE: flower has to be first because obj2 is NULL for it!
							if (shp.m_categoryBits&CollInfo.COLL_CATEGORY_FLOWER)
							{
								//temp_flower = ((Flower)(obj2));
								flower.shrink(((Ball)(obj1)).getHps());	
								((Ball)(obj1)).clearHps();
								((Ball)(obj1)).setForDelete();

								sound_flag_ballhitflower = true;

							}
							if (obj2 is Collector)
							{
								flower.grow(((Ball)(obj1)).getHps());
								((Ball)(obj1)).clearHps();
								((Ball)(obj1)).setForDelete();

								sound_flag_ballin = true;

							}
							else if (obj2 is Barrier)
							{
								temp_barrier = ((Barrier)(obj2));
								temp_barrier.setFlash();

								v = obj1.getCollBody().GetLinearVelocity();
								vel = new Point(v.x,v.y);
								if (Vector.getMagnitude(vel) > 100)
									sound_flag_ballhitbarrier = true;

								((Ball)(obj1)).fragmentMe();;

							}
							else if (obj2 is Doomsday)
							{
								temp_doomsday = ((Doomsday)(obj2));
								temp_doomsday.reset();
							}
							else if (obj2 is Bar)
							{
								v = obj1.getCollBody().GetLinearVelocity();
								vel = new Point(v.x,v.y);
								if (Vector.getMagnitude(vel) > 100)
									sound_flag_ballhitbar = true;

							}


							((Ball)(obj1)).checkSpeed();

						}
						else if (obj2 is Ball)
						{
							//get 1st shape of obj1's coll body
							cbody = body1;
							shp = cbody.GetShapeList();

							//NOTE: flower has to be first because obj1 is NULL for it!
							if (shp.m_categoryBits&CollInfo.COLL_CATEGORY_FLOWER)
							{
								//temp_flower = ((Flower)(obj1));
								flower.shrink(((Ball)(obj2)).getHps());
								((Ball)(obj2)).clearHps();
								((Ball)(obj2)).setForDelete();

								sound_flag_ballhitflower = true;

							}
							else if (obj1 is Collector)
							{
								flower.grow(((Ball)(obj2)).getHps());
								((Ball)(obj2)).clearHps();
								((Ball)(obj2)).setForDelete();

								sound_flag_ballin = true;

							}
							else if (obj1 is Barrier)
							{
								temp_barrier = ((Barrier)(obj1));
								temp_barrier.setFlash();

								v = obj2.getCollBody().GetLinearVelocity();
								vel = new Point(v.x,v.y);
								if (Vector.getMagnitude(vel) > 100)
									sound_flag_ballhitbarrier = true;

								((Ball)(obj2)).fragmentMe();;

							}
							else if (obj1 is Doomsday)
							{
								temp_doomsday = ((Doomsday)(obj1));
								temp_doomsday.reset();
							}
							else if (obj1 is Bar)
							{
								v = obj2.getCollBody().GetLinearVelocity();
								vel = new Point(v.x,v.y);
								if (Vector.getMagnitude(vel) > 100)
									sound_flag_ballhitbar = true;

							}


							((Ball)(obj2)).checkSpeed();

						}
						else if (obj1 is Egg)
						{
							if (obj2 is Bar)
							{
								if ((Egg)(obj1).getEnergy() > 0)
								{
									upgrade((Egg)(obj1));
									(Egg)(obj1).clearEnergy();
								}
								((Egg)(obj1)).setForDelete();
							}
						}
						else if (obj2 is Egg)
						{
							if (obj1 is Bar)
							{
								if ((Egg)(obj2).getEnergy() > 0)
								{
									upgrade((Egg)(obj2));
									(Egg)(obj2).clearEnergy();
								}
								((Egg)(obj2)).setForDelete();
							}
						}	
						else if (obj1 is Doomsday)
						{						//get 1st shape of obj1's coll body
							cbody = body2;
							shp = cbody.GetShapeList();

							//NOTE: flower has to be first because obj2 is NULL for it!
							if (shp.m_categoryBits&CollInfo.COLL_CATEGORY_FLOWER)
							{
								flower.shrink(((Doomsday)(obj1)).getHps());
								((Doomsday)(obj1)).clearHps();
								((Doomsday)(obj1)).setForDelete();
							}
						}
						else if (obj2 is Doomsday)
						{
							cbody = body1;
							shp = cbody.GetShapeList();

							//NOTE: flower has to be first because obj2 is NULL for it!
							if (shp.m_categoryBits&CollInfo.COLL_CATEGORY_FLOWER)
							{
								flower.shrink(((Doomsday)(obj2)).getHps());
								((Doomsday)(obj2)).clearHps();
								((Doomsday)(obj2)).setForDelete();
							}

						}
						else if (obj1 is Bar)
						{ 
							if (obj2 is Barrier)
							{
								temp_barrier = ((Barrier)(obj2));
								temp_barrier.setFlash();
							}
							else if (obj2 is Mechanix)
							{
								temp_mechanix = ((Mechanix)(obj2));
								temp_mechanix.forceToShoot();
							}

						}
						else if (obj2 is Bar)
						{
							if (obj1 is Barrier)
							{
								temp_barrier = ((Barrier)(obj1));
								temp_barrier.setFlash();
							}
							else if (obj1 is Mechanix)
							{
								temp_mechanix = ((Mechanix)(obj1));
								temp_mechanix.forceToShoot();
							}
						}

					}
				}     
			}			
			
			if (sound_flag_ballin_cnt > 0)
				sound_flag_ballin_cnt--;
			if (sound_flag_ballhitbar_cnt > 0)
				sound_flag_ballhitbar_cnt--;
			if (sound_flag_ballhitbarrier_cnt > 0)
				sound_flag_ballhitbarrier_cnt--;
			if (sound_flag_ballhitflower_cnt > 0)
				sound_flag_ballhitflower_cnt--;
			
			if (sound_flag_ballin && sound_flag_ballin_cnt < 1)
			{
				GameSounds.playBallIn();
				sound_flag_ballin_cnt = 10;
			}
			if (sound_flag_ballhitbar && sound_flag_ballhitbar_cnt < 1)
			{
				GameSounds.playBallHitBar();
				sound_flag_ballhitbar_cnt = 10;
			}
			if (sound_flag_ballhitbarrier && sound_flag_ballhitbarrier_cnt < 1)
			{
				GameSounds.playBallHitBarrier();
				sound_flag_ballhitbarrier_cnt = 10;			
			}
			if (sound_flag_ballhitflower && sound_flag_ballhitflower_cnt < 1)
			{
				GameSounds.playFlowerHit();
				sound_flag_ballhitflower_cnt = 10;			
			}
			
			doFragmenting();
						
		}







		///////////////////////////////////////////////////////////////////////////
		//
		//
		//
		///////////////////////////////////////////////////////////////////////////
		private function getWow():String
		{
		
			var rand:int = Random.getInt(wow_list.length);
		
			if (((Cabol)(game)).array_flower_info.length == 1)
				rand = 0;
						
			return wow_list[rand];
		
		}



		

		///////////////////////////////////////////////////////////////////////////
		//
		// upgrade for the player (after catching an egg)
		//
		///////////////////////////////////////////////////////////////////////////
		private function upgrade(egg:Egg):void
		{

			//get egg type
			var type:int = egg.getType();

			if (type == Egg.TYPE_GROW_FLOWER)
			{
				flower.grow(1);
			}
			else //if (type == Egg.GROW_ALL)
			{
				flower.growFull();
			}

			GameSounds.playUpgrade();

		}



		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		private function generateLevelBarriers(lev:int):void
		{
			var i:int;

			var max:int;
			var rand1:int;
			var rand:int;

			if (lev == 0)
				return;
				
			if (lev > 5)
				max = 5;
			else
				max = lev;

	
			rand1 = Random.getInt(max);


			for(i=0;i<rand1;i++)	
			{
				rand = Random.getInt(16);
				genLevBarr(rand);
			}


		}			




		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		private function genLevBarr(type:int):void
		{

			var gobj:GameObj;
			var size_obj:Point = new Point();
			var flags:uint;



			if (type == 0)
			{	
				size_obj.x = 55;
				size_obj.y = 25;
				flags = GameObj.FLAG_COLLIDABLE_SOLID|GameObj.FLAG_DISPLAYABLE;
				gobj = new Barrier(game,game,new Point(0 + size_obj.x/2 + 15,game.getScreenY()/2 + (game.getScreenY()/8)), new Point(size_obj.x, size_obj.y),flags,false,Barrier.TYPE_REG);
				gameObjListAdd(gobj);
			}
			else if (type == 1)
			{
				size_obj.x = 55;
				size_obj.y = 25;
				flags = GameObj.FLAG_COLLIDABLE_SOLID|GameObj.FLAG_DISPLAYABLE;
				gobj = new Barrier(game,game,new Point(game.getScreenX() - size_obj.x/2 - 15,game.getScreenY()/2 + (game.getScreenY()/8)), new Point(size_obj.x, size_obj.y),flags,false,Barrier.TYPE_REG);
				gameObjListAdd(gobj);
			}
			else if (type == 2)
			{
				size_obj.x = 40;
				size_obj.y = 40;
				flags = GameObj.FLAG_COLLIDABLE|GameObj.FLAG_DISPLAYABLE;
				gobj = new Barrier(game,game,new Point(game.getScreenX()/2 - (game.getScreenX()/6),game.getScreenY()/8), new Point(size_obj.x, size_obj.y),flags,false,Barrier.TYPE_REG);
				gameObjListAdd(gobj);
			}
			else if (type == 3)
			{
				size_obj.x = 40;
				size_obj.y = 40;
				flags = GameObj.FLAG_COLLIDABLE|GameObj.FLAG_DISPLAYABLE;
				gobj = new Barrier(game,game,new Point(game.getScreenX()/2 + (game.getScreenX()/6),game.getScreenY()/8), new Point(size_obj.x, size_obj.y),flags,false,Barrier.TYPE_REG);
				gameObjListAdd(gobj);
			}
			else if (type == 4)
			{
				size_obj.x = 40;
				size_obj.y = 40;
				flags = GameObj.FLAG_COLLIDABLE|GameObj.FLAG_DISPLAYABLE;
				gobj = new Barrier(game,game,new Point(game.getScreenX()/2,game.getScreenY()/2- (game.getScreenY()/12)), new Point(size_obj.x, size_obj.y),flags,false,Barrier.TYPE_REG);
				gameObjListAdd(gobj);
			}
			else if (type == 5)
			{
				size_obj.x = 40;
				size_obj.y = 40;
				flags = GameObj.FLAG_COLLIDABLE|GameObj.FLAG_DISPLAYABLE;
				gobj = new Barrier(game,game,new Point(game.getScreenX()/2 - (game.getScreenX()/2.5),game.getScreenY()/2), new Point(size_obj.x, size_obj.y),flags,false,Barrier.TYPE_BOX_A);
				gameObjListAdd(gobj);
			}
			else if (type == 6)
			{
				size_obj.x = 40;
				size_obj.y = 40;
				flags = GameObj.FLAG_COLLIDABLE|GameObj.FLAG_DISPLAYABLE;
				gobj = new Barrier(game,game,new Point(game.getScreenX()/2 + (game.getScreenX()/2.5),game.getScreenY()/2), new Point(size_obj.x, size_obj.y),flags,false,Barrier.TYPE_BOX_A);
				gameObjListAdd(gobj);
			}
			else if (type == 7)
			{			
				flags = GameObj.FLAG_COLLIDABLE_SOLID|GameObj.FLAG_DISPLAYABLE;
				size_obj.x = 80;
				size_obj.y = 20;
				gobj = new Barrier(game,game,new Point(0 + size_obj.x/2,game.getScreenY()/3), new Point(size_obj.x, size_obj.y),flags,false,Barrier.TYPE_BOX_B);
				gameObjListAdd(gobj);
			}
			else if (type == 8)
			{
				flags = GameObj.FLAG_COLLIDABLE_SOLID|GameObj.FLAG_DISPLAYABLE;
				size_obj.x = 80;
				size_obj.y = 20;
				gobj = new Barrier(game,game,new Point(game.getScreenX()-size_obj.x/2,game.getScreenY()/3), new Point(size_obj.x, size_obj.y),flags,false,Barrier.TYPE_BOX_B);
				gameObjListAdd(gobj);
			}
			else if (type == 9)
			{
				size_obj.x = 11;
				size_obj.y = 100;
				flags = GameObj.FLAG_COLLIDABLE|GameObj.FLAG_DISPLAYABLE;
				gobj = new Barrier(game,game,new Point(game.getScreenX()/2 - (game.getScreenX()/5),game.getScreenY()/2), new Point(size_obj.x, size_obj.y),flags,false,Barrier.TYPE_BOX_A);
				gobj.setRot(-0.78);
				gameObjListAdd(gobj);
			}
			else if (type == 10)
			{
				size_obj.x = 11;
				size_obj.y = 100;
				flags = GameObj.FLAG_COLLIDABLE|GameObj.FLAG_DISPLAYABLE;
				gobj = new Barrier(game,game,new Point(game.getScreenX()/2 + (game.getScreenX()/5),game.getScreenY()/2), new Point(size_obj.x, size_obj.y),flags,false,Barrier.TYPE_BOX_A);
				gobj.setRot(0.78);
				gameObjListAdd(gobj);
			}
			else if (type == 11)
			{
				flags = GameObj.FLAG_COLLIDABLE_SOLID|GameObj.FLAG_DISPLAYABLE;
				size_obj.x = 15;
				size_obj.y = 60;
				gobj = new Barrier(game,game,new Point(game.getScreenX()/2 + game.getScreenX()/4,game.getScreenY()/3.5), new Point(size_obj.x, size_obj.y),flags,false,Barrier.TYPE_BOX_A);
				gameObjListAdd(gobj);
			}
			else if (type == 12)
			{	
				size_obj.x = 15;
				size_obj.y = 60;
				flags = GameObj.FLAG_COLLIDABLE_SOLID|GameObj.FLAG_DISPLAYABLE;
				gobj = new Barrier(game,game,new Point(game.getScreenX()/2 - game.getScreenX()/4,game.getScreenY()/3.5), new Point(size_obj.x, size_obj.y),flags,false,Barrier.TYPE_BOX_A);
				gameObjListAdd(gobj);
			}
			else if (type == 13)
			{	
				size_obj.x = 20;
				size_obj.y = 200;
				flags = GameObj.FLAG_COLLIDABLE_SOLID|GameObj.FLAG_DISPLAYABLE;
				gobj = new Barrier(game,game,new Point(game.getScreenX()/2,game.getScreenY()/3.5), new Point(size_obj.x, size_obj.y),flags,false,Barrier.TYPE_BOX_A);
				gameObjListAdd(gobj);
			}
			else if (type == 14)
			{
				size_obj.x = 50;
				size_obj.y = 20;
				flags = GameObj.FLAG_COLLIDABLE_SOLID|GameObj.FLAG_DISPLAYABLE;
				gobj = new Barrier(game,game,new Point(game.getScreenX() - size_obj.x/2 - 18,game.getScreenY()/6), new Point(size_obj.x, size_obj.y),flags,false,Barrier.TYPE_REG);
				gameObjListAdd(gobj);
			}
			else //if (type == 15)
			{
				size_obj.x = 50;
				size_obj.y = 20;
				flags = GameObj.FLAG_COLLIDABLE_SOLID|GameObj.FLAG_DISPLAYABLE;
				gobj = new Barrier(game,game,new Point(0 + size_obj.x/2 + 18,game.getScreenY()/6), new Point(size_obj.x, size_obj.y),flags,false,Barrier.TYPE_REG);
				gameObjListAdd(gobj);
			}


		}	


		
		
		

		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		private function generateLevelMechanix(lev:int):void
		{
			var i:int;

			var num:int;
			var rand:int;


			if (lev < 3)
				num = 1;
			else //if (lev < 6)
				num = Random.getInt(2) + 1;

			for(i=0;i<num;i++)	
			{
				rand = Random.getInt(5);
		
				if (lev == 0)
					rand = 0;
					
				genLevMech(rand,lev);
			}
		}
		

		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		private function genLevMech(type:int, lev:int):void
		{

			var gobj:GameObj;
			var size_obj:Point = new Point();
			var the_pos:Point;
			var the_size:Point;
			var abil:int;
			
			//calculate ability level based on game level
			//ability goes from 1-5
			if (lev < 3)
				abil = 1;
			else if (lev < 6)
				abil = 2;
			else //if (lev < 10)
				abil = 3;
							
			the_pos = new Point(game.getScreenX()/2, size_obj.y/2);
			
			if (type == 0)
			{
				size_obj.x = 20;
				size_obj.y = 20;
				the_size = new Point(size_obj.x,size_obj.y);

				gobj = new Mechanix(game, game, the_pos,the_size, Mechanix.TYPE_BASIC,abil,this);
				gameObjListAdd(gobj);
			}
			else if (type == 1)
			{
				size_obj.x = 30;
				size_obj.y = 30;
				the_size = new Point(size_obj.x,size_obj.y);

				gobj = new Mechanix(game, game,  the_pos,the_size, Mechanix.TYPE_POWER,abil,this);
				gameObjListAdd(gobj);
			}
			else if (type == 2)
			{
				size_obj.x = 25;
				size_obj.y = 25;
				the_size = new Point(size_obj.x,size_obj.y);

				gobj = new Mechanix(game, game, the_pos,the_size, Mechanix.TYPE_SPINNER,abil,this);
				gameObjListAdd(gobj);
			}
			else if (type == 3)
			{
				size_obj.x = 20;
				size_obj.y = 20;
				the_size = new Point(size_obj.x,size_obj.y);

				gobj = new Mechanix(game, game,  the_pos,the_size, Mechanix.TYPE_SPEEDY,abil,this);
				gameObjListAdd(gobj);
			}
			else //if (type == 4)
			{
				size_obj.x = 20;
				size_obj.y = 20;
				the_size = new Point(size_obj.x,size_obj.y);

				gobj = new Mechanix(game, game,  the_pos,the_size, Mechanix.TYPE_QUEEN,abil,this);
				gameObjListAdd(gobj);

			}


		}	


		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		private function doFragmenting():void
		{
			var i:int;
			var ball:Ball;
			var new_ball:Ball;
			
			for (i=0;i<game_obj_list.length;i++)
			{
				if (game_obj_list[i] is Ball) 
				{
					ball = game_obj_list[i];
					if (ball.shouldFragment())
					{						
						//create a new balls with a smaller size
						new_ball = new Ball(game, game, new Point(ball.getX(),ball.getY()),ball.getParentMechanix(),ball.getVel(),Ball.TYPE_KILLER,new Point(ball.getSizeX() * 0.80, ball.getSizeY() * 0.80),ball.getLev());
						gameObjListAdd(new_ball);
						new_ball = new Ball(game, game, new Point(ball.getX(),ball.getY()),ball.getParentMechanix(),ball.getVel(),Ball.TYPE_KILLER,new Point(ball.getSizeX() * 0.80, ball.getSizeY() * 0.80),ball.getLev());
						gameObjListAdd(new_ball);

						//delete original ball
						ball.clearFragment();
						ball.setForDelete();
					}
				}
			}

		}



		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function gameObjListAdd(obj:DisplayObject):void
		{
			game_obj_list.push(obj); 

		}
		

		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function gameObjListRemove(obj:DisplayObject):void
		{ 
		
			var idx:int = game_obj_list.indexOf(obj); 
			game_obj_list.splice(idx,1);
		}


		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function getBar():Bar { return game_bar; }

	}
}