

////////////////////////////////////////////////////////////////////////
//
// 
//
////////////////////////////////////////////////////////////////////////


package
{

	include "ImportFile.as"


	public class Petal extends GameObj
	{

		public static const SHAPE_ELLIPSE_REG:uint = 0;	
		public static const SHAPE_ELLIPSE_THIN:uint =  1;	
		public static const SHAPE_ELLIPSE_FAT:uint =  2;	
		public static const SHAPE_ELLIPSE_CIRCLE:uint = 3;	
		public static const SHAPE_MAX:uint 	=  4;	

		private var type:int;
		private var base_pos:Point;
		private var color_set:int;
		
		private var level:int;
		
		private var parent_flower:Flower;
		
		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public function Petal(game:Game, pobj:Sprite, x:int, y:int, in_type:int, size_base:Point, flags:uint, in_color_set:int, in_level:int)
		{
			color_set = in_color_set;
		
			parent_flower = (Flower)(pobj);
		
			type = in_type;
			
			level = in_level;

			base_pos = new Point(x,y);

			//center of the flower
			super(game, pobj, new Point(x, y), new Point(size_base.x, size_base.y), flags,0,0);
			
			
			
		}


		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public override function shutdown():void
		{
			super.shutdown();
			filters = new Array();
			graphics.clear();
		}

		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		private function getBitmapFilter():BitmapFilter
		{
			var color:Number = ((Flower)(pobj)).flower_info.glow_color;

			var alpha:Number = 0.8;
			var blurX:Number = 35;
			var blurY:Number = 35;
			var strength:Number = 2;
			var inner:Boolean = false;
			var knockout:Boolean = false;
			var quality:Number = BitmapFilterQuality.LOW;

			return new GlowFilter(color,
					  alpha,
					  blurX,
					  blurY,
					  strength,
					  quality,
					  inner,
					  knockout);
		}



		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public function getLevel():int { return level; }
		public function getColorSet():int { return color_set; }
		public function getType():int { return type; }



		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public override function draw():void
		{

			var grfx:Graphics = this.graphics;

			
			grfx.clear();


			if (level == 1 && parent_flower.getAge() < Flower.AGE_STAGE_2)
			{
				filters = new Array();
				return;
			}
			
			if (level == 2 && parent_flower.getAge() < Flower.AGE_STAGE_3)
			{
				filters = new Array();
				return;
			}
			
			if (level == 2)
			{
				var filter:BitmapFilter = getBitmapFilter();
			        var myFilters:Array = new Array();
				myFilters.push(filter);
				filters = myFilters;
			}
			
			
	
			var flower:Flower = ((Flower)(pobj));
		

			var col:Array;
			var alp:Array;
			var rat:Array;

			if (color_set == 1)
			{
				col = flower.flower_info.colors1;
				alp = flower.flower_info.alphas1;
				rat = flower.flower_info.ratios1;
			}
			else if (color_set == 2)
			{
				col = flower.flower_info.colors2;
				alp = flower.flower_info.alphas2;
				rat = flower.flower_info.ratios2;
			}
			else //if (color_set == 3)
			{
				col = flower.flower_info.colors3;
				alp = flower.flower_info.alphas3;
				rat = flower.flower_info.ratios3;
			}


			grfx.beginGradientFill(GradientType.RADIAL,
				       col,
				       alp,
				       rat,
				       null,
				       SpreadMethod.PAD,
				       InterpolationMethod.RGB,
				       0.0);


			//adjust petal sizes based on level of petals
			var size_adjuster:Number;
			if (level == 0)
				size_adjuster = 0.7;
			else if (level == 1)
				size_adjuster = 0.8;
			else // if (level == 2)
				size_adjuster = 0.95;


			if (type == SHAPE_ELLIPSE_REG)
			{				
				grfx.drawEllipse(-size.x/2,-size.y/2,(size.x*2) * size_adjuster,size.y * size_adjuster);
			}
			else if (type == SHAPE_ELLIPSE_THIN)
			{				
				grfx.drawEllipse(-size.x/2,-size.y/2,(size.x*2.1) * size_adjuster,(size.y * 0.50) * size_adjuster);
			}
			else if (type == SHAPE_ELLIPSE_FAT)
			{				

				grfx.drawEllipse(-size.x/2,-size.y/2,(size.x*1.5) * size_adjuster,(size.y * 2.0) * size_adjuster);
			}
			else //if (type == SHAPE_ELLIPSE_CIRCLE)
			{				

				grfx.drawEllipse(-size.x/2,-size.y/2,(size.x) * size_adjuster,(size.y) * size_adjuster);
			}
			graphics.endFill();


		}

	}
}